VERSION 5.00
Begin VB.Form DriveSerialUI 
   Caption         =   "DriveSerial - DriveInfo/UsbFlashSerial Demo"
   ClientHeight    =   7755
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   8460
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "DriveSerialUI.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   7755
   ScaleWidth      =   8460
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtLog 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4275
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   240
      Width           =   8415
   End
End
Attribute VB_Name = "DriveSerialUI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetLogicalDrives Lib "kernel32" () As Long

Private DriveInfo As DriveInfo

Private Function GetDrives() As String()
    'Returns drive letters in the system.  If no drives (?) then
    'returns an emoty array(LBound = 0 and UBound = -1).
    Dim Drives() As String
    Dim Bits As Long
    Dim BitNum As Long
    Dim NextDrive As Long
    
    ReDim Drives(25)
    Bits = GetLogicalDrives()
    For BitNum = 0 To 25
        If Bits And 1 Then
            Drives(NextDrive) = ChrW$(&H41 + BitNum)
            NextDrive = NextDrive + 1
        End If
        Bits = Bits \ 2
    Next
    If NextDrive > 0 Then
        ReDim Preserve Drives(NextDrive - 1)
    Else
        Drives = Split(vbNullString)
    End If
    GetDrives = Drives
End Function

Private Sub Log(ByVal Text As String)
    With txtLog
        .SelStart = &H7FFF
        .SelText = Text
    End With
End Sub

Private Sub LogLine(Optional ByVal Text As String)
    If Len(Text) > 0 Then Log Text
    Log vbNewLine
End Sub

Private Sub LogInfo(ByVal DriveLetter As String)
    With DriveInfo
        On Error Resume Next
        .Letter = DriveLetter
        If Err Then
            LogLine "Error &H" & Hex$(Err.Number) & " " & Err.Description
            On Error GoTo 0
            LogLine "Drive letter: """ & DriveLetter & """"
            LogLine
        Else
            On Error GoTo 0
            LogLine "Drive letter: """ & .Letter & """"
            LogLine "    BusType = " & .BusType & " (" & .BusTypeText & ")"
            LogLine "    DeviceType = " & .DeviceType & " (" & .DeviceTypeText & ")"
            LogLine "    ProductId = """ & .ProductId & """"
            LogLine "    ProductRevision = """ & .ProductRevision & """"
            LogLine "    Removable = " & CStr(.Removable)
            LogLine "    SerialNumber = """ & .SerialNumber & """"
            LogLine "    VendorId = """ & .VendorId & """"
            LogLine
        End If
    End With
End Sub

Private Sub Form_Load()
    Dim Drives() As String
    Dim DriveNum As Long
    
    Set DriveInfo = New DriveInfo
    Drives = GetDrives()
    If UBound(Drives) < LBound(Drives) Then
        LogLine "No drives!"
    Else
        For DriveNum = LBound(Drives) To UBound(Drives)
            LogInfo Drives(DriveNum)
        Next
    End If
End Sub

Private Sub Form_Resize()
    If WindowState <> vbMinimized Then
        txtLog.Move 0, 0, ScaleWidth, ScaleHeight
    End If
End Sub
